# autogenerated module
from dataclasses import dataclass, field
from typing import List

from ..core.dataclasses_dict import DataclassDictMixIn

from . import meta_v1


@dataclass
class MutatingWebhook(DataclassDictMixIn):
    clientConfig: 'WebhookClientConfig'
    name: 'str'
    admissionReviewVersions: 'List[str]' = None
    failurePolicy: 'str' = None
    matchPolicy: 'str' = None
    namespaceSelector: 'meta_v1.LabelSelector' = None
    objectSelector: 'meta_v1.LabelSelector' = None
    reinvocationPolicy: 'str' = None
    rules: 'List[RuleWithOperations]' = None
    sideEffects: 'str' = None
    timeoutSeconds: 'int' = None


@dataclass
class MutatingWebhookConfiguration(DataclassDictMixIn):
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    webhooks: 'List[MutatingWebhook]' = None


@dataclass
class MutatingWebhookConfigurationList(DataclassDictMixIn):
    items: 'List[MutatingWebhookConfiguration]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class RuleWithOperations(DataclassDictMixIn):
    apiGroups: 'List[str]' = None
    apiVersions: 'List[str]' = None
    operations: 'List[str]' = None
    resources: 'List[str]' = None
    scope: 'str' = None


@dataclass
class ServiceReference(DataclassDictMixIn):
    name: 'str'
    namespace: 'str'
    path: 'str' = None
    port: 'int' = None


@dataclass
class ValidatingWebhook(DataclassDictMixIn):
    clientConfig: 'WebhookClientConfig'
    name: 'str'
    admissionReviewVersions: 'List[str]' = None
    failurePolicy: 'str' = None
    matchPolicy: 'str' = None
    namespaceSelector: 'meta_v1.LabelSelector' = None
    objectSelector: 'meta_v1.LabelSelector' = None
    rules: 'List[RuleWithOperations]' = None
    sideEffects: 'str' = None
    timeoutSeconds: 'int' = None


@dataclass
class ValidatingWebhookConfiguration(DataclassDictMixIn):
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    webhooks: 'List[ValidatingWebhook]' = None


@dataclass
class ValidatingWebhookConfigurationList(DataclassDictMixIn):
    items: 'List[ValidatingWebhookConfiguration]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class WebhookClientConfig(DataclassDictMixIn):
    caBundle: 'str' = None
    service: 'ServiceReference' = None
    url: 'str' = None


