# autogenerated module
from dataclasses import dataclass, field
from typing import List

from ..core.dataclasses_dict import DataclassDictMixIn

from . import meta_v1


@dataclass
class LocalSubjectAccessReview(DataclassDictMixIn):
    spec: 'SubjectAccessReviewSpec'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    status: 'SubjectAccessReviewStatus' = None


@dataclass
class NonResourceAttributes(DataclassDictMixIn):
    path: 'str' = None
    verb: 'str' = None


@dataclass
class NonResourceRule(DataclassDictMixIn):
    verbs: 'List[str]'
    nonResourceURLs: 'List[str]' = None


@dataclass
class ResourceAttributes(DataclassDictMixIn):
    group: 'str' = None
    name: 'str' = None
    namespace: 'str' = None
    resource: 'str' = None
    subresource: 'str' = None
    verb: 'str' = None
    version: 'str' = None


@dataclass
class ResourceRule(DataclassDictMixIn):
    verbs: 'List[str]'
    apiGroups: 'List[str]' = None
    resourceNames: 'List[str]' = None
    resources: 'List[str]' = None


@dataclass
class SelfSubjectAccessReview(DataclassDictMixIn):
    spec: 'SelfSubjectAccessReviewSpec'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    status: 'SubjectAccessReviewStatus' = None


@dataclass
class SelfSubjectAccessReviewSpec(DataclassDictMixIn):
    nonResourceAttributes: 'NonResourceAttributes' = None
    resourceAttributes: 'ResourceAttributes' = None


@dataclass
class SelfSubjectRulesReview(DataclassDictMixIn):
    spec: 'SelfSubjectRulesReviewSpec'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    status: 'SubjectRulesReviewStatus' = None


@dataclass
class SelfSubjectRulesReviewSpec(DataclassDictMixIn):
    namespace: 'str' = None


@dataclass
class SubjectAccessReview(DataclassDictMixIn):
    spec: 'SubjectAccessReviewSpec'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    status: 'SubjectAccessReviewStatus' = None


@dataclass
class SubjectAccessReviewSpec(DataclassDictMixIn):
    extra: 'dict' = None
    groups: 'List[str]' = None
    nonResourceAttributes: 'NonResourceAttributes' = None
    resourceAttributes: 'ResourceAttributes' = None
    uid: 'str' = None
    user: 'str' = None


@dataclass
class SubjectAccessReviewStatus(DataclassDictMixIn):
    allowed: 'bool'
    denied: 'bool' = None
    evaluationError: 'str' = None
    reason: 'str' = None


@dataclass
class SubjectRulesReviewStatus(DataclassDictMixIn):
    incomplete: 'bool'
    nonResourceRules: 'List[NonResourceRule]'
    resourceRules: 'List[ResourceRule]'
    evaluationError: 'str' = None


