# autogenerated module
from dataclasses import dataclass, field
from typing import List

from ..core.dataclasses_dict import DataclassDictMixIn

from . import meta_v1
from . import core_v1


@dataclass
class Job(DataclassDictMixIn):
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'JobSpec' = None
    status: 'JobStatus' = None


@dataclass
class JobCondition(DataclassDictMixIn):
    status: 'str'
    type: 'str'
    lastProbeTime: 'meta_v1.Time' = None
    lastTransitionTime: 'meta_v1.Time' = None
    message: 'str' = None
    reason: 'str' = None


@dataclass
class JobList(DataclassDictMixIn):
    items: 'List[Job]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class JobSpec(DataclassDictMixIn):
    template: 'core_v1.PodTemplateSpec'
    activeDeadlineSeconds: 'int' = None
    backoffLimit: 'int' = None
    completions: 'int' = None
    manualSelector: 'bool' = None
    parallelism: 'int' = None
    selector: 'meta_v1.LabelSelector' = None
    ttlSecondsAfterFinished: 'int' = None


@dataclass
class JobStatus(DataclassDictMixIn):
    active: 'int' = None
    completionTime: 'meta_v1.Time' = None
    conditions: 'List[JobCondition]' = None
    failed: 'int' = None
    startTime: 'meta_v1.Time' = None
    succeeded: 'int' = None


