# autogenerated module
from dataclasses import dataclass, field
from typing import List

from ..core.dataclasses_dict import DataclassDictMixIn

from . import meta_v1
from . import util_intstr
from . import resource


@dataclass
class AWSElasticBlockStoreVolumeSource(DataclassDictMixIn):
    volumeID: 'str'
    fsType: 'str' = None
    partition: 'int' = None
    readOnly: 'bool' = None


@dataclass
class Affinity(DataclassDictMixIn):
    nodeAffinity: 'NodeAffinity' = None
    podAffinity: 'PodAffinity' = None
    podAntiAffinity: 'PodAntiAffinity' = None


@dataclass
class AttachedVolume(DataclassDictMixIn):
    devicePath: 'str'
    name: 'str'


@dataclass
class AzureDiskVolumeSource(DataclassDictMixIn):
    diskName: 'str'
    diskURI: 'str'
    cachingMode: 'str' = None
    fsType: 'str' = None
    kind: 'str' = None
    readOnly: 'bool' = None


@dataclass
class AzureFilePersistentVolumeSource(DataclassDictMixIn):
    secretName: 'str'
    shareName: 'str'
    readOnly: 'bool' = None
    secretNamespace: 'str' = None


@dataclass
class AzureFileVolumeSource(DataclassDictMixIn):
    secretName: 'str'
    shareName: 'str'
    readOnly: 'bool' = None


@dataclass
class Binding(DataclassDictMixIn):
    target: 'ObjectReference'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None


@dataclass
class CSIPersistentVolumeSource(DataclassDictMixIn):
    driver: 'str'
    volumeHandle: 'str'
    controllerExpandSecretRef: 'SecretReference' = None
    controllerPublishSecretRef: 'SecretReference' = None
    fsType: 'str' = None
    nodePublishSecretRef: 'SecretReference' = None
    nodeStageSecretRef: 'SecretReference' = None
    readOnly: 'bool' = None
    volumeAttributes: 'dict' = None


@dataclass
class CSIVolumeSource(DataclassDictMixIn):
    driver: 'str'
    fsType: 'str' = None
    nodePublishSecretRef: 'LocalObjectReference' = None
    readOnly: 'bool' = None
    volumeAttributes: 'dict' = None


@dataclass
class Capabilities(DataclassDictMixIn):
    add: 'List[str]' = None
    drop: 'List[str]' = None


@dataclass
class CephFSPersistentVolumeSource(DataclassDictMixIn):
    monitors: 'List[str]'
    path: 'str' = None
    readOnly: 'bool' = None
    secretFile: 'str' = None
    secretRef: 'SecretReference' = None
    user: 'str' = None


@dataclass
class CephFSVolumeSource(DataclassDictMixIn):
    monitors: 'List[str]'
    path: 'str' = None
    readOnly: 'bool' = None
    secretFile: 'str' = None
    secretRef: 'LocalObjectReference' = None
    user: 'str' = None


@dataclass
class CinderPersistentVolumeSource(DataclassDictMixIn):
    volumeID: 'str'
    fsType: 'str' = None
    readOnly: 'bool' = None
    secretRef: 'SecretReference' = None


@dataclass
class CinderVolumeSource(DataclassDictMixIn):
    volumeID: 'str'
    fsType: 'str' = None
    readOnly: 'bool' = None
    secretRef: 'LocalObjectReference' = None


@dataclass
class ClientIPConfig(DataclassDictMixIn):
    timeoutSeconds: 'int' = None


@dataclass
class ComponentCondition(DataclassDictMixIn):
    status: 'str'
    type: 'str'
    error: 'str' = None
    message: 'str' = None


@dataclass
class ComponentStatus(DataclassDictMixIn):
    apiVersion: 'str' = None
    conditions: 'List[ComponentCondition]' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None


@dataclass
class ComponentStatusList(DataclassDictMixIn):
    items: 'List[ComponentStatus]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class ConfigMap(DataclassDictMixIn):
    apiVersion: 'str' = None
    binaryData: 'dict' = None
    data: 'dict' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None


@dataclass
class ConfigMapEnvSource(DataclassDictMixIn):
    name: 'str' = None
    optional: 'bool' = None


@dataclass
class ConfigMapKeySelector(DataclassDictMixIn):
    key: 'str'
    name: 'str' = None
    optional: 'bool' = None


@dataclass
class ConfigMapList(DataclassDictMixIn):
    items: 'List[ConfigMap]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class ConfigMapNodeConfigSource(DataclassDictMixIn):
    kubeletConfigKey: 'str'
    name: 'str'
    namespace: 'str'
    resourceVersion: 'str' = None
    uid: 'str' = None


@dataclass
class ConfigMapProjection(DataclassDictMixIn):
    items: 'List[KeyToPath]' = None
    name: 'str' = None
    optional: 'bool' = None


@dataclass
class ConfigMapVolumeSource(DataclassDictMixIn):
    defaultMode: 'int' = None
    items: 'List[KeyToPath]' = None
    name: 'str' = None
    optional: 'bool' = None


@dataclass
class Container(DataclassDictMixIn):
    name: 'str'
    args: 'List[str]' = None
    command: 'List[str]' = None
    env: 'List[EnvVar]' = None
    envFrom: 'List[EnvFromSource]' = None
    image: 'str' = None
    imagePullPolicy: 'str' = None
    lifecycle: 'Lifecycle' = None
    livenessProbe: 'Probe' = None
    ports: 'List[ContainerPort]' = None
    readinessProbe: 'Probe' = None
    resources: 'ResourceRequirements' = None
    securityContext: 'SecurityContext' = None
    stdin: 'bool' = None
    stdinOnce: 'bool' = None
    terminationMessagePath: 'str' = None
    terminationMessagePolicy: 'str' = None
    tty: 'bool' = None
    volumeDevices: 'List[VolumeDevice]' = None
    volumeMounts: 'List[VolumeMount]' = None
    workingDir: 'str' = None


@dataclass
class ContainerImage(DataclassDictMixIn):
    names: 'List[str]'
    sizeBytes: 'int' = None


@dataclass
class ContainerPort(DataclassDictMixIn):
    containerPort: 'int'
    hostIP: 'str' = None
    hostPort: 'int' = None
    name: 'str' = None
    protocol: 'str' = None


@dataclass
class ContainerState(DataclassDictMixIn):
    running: 'ContainerStateRunning' = None
    terminated: 'ContainerStateTerminated' = None
    waiting: 'ContainerStateWaiting' = None


@dataclass
class ContainerStateRunning(DataclassDictMixIn):
    startedAt: 'meta_v1.Time' = None


@dataclass
class ContainerStateTerminated(DataclassDictMixIn):
    exitCode: 'int'
    containerID: 'str' = None
    finishedAt: 'meta_v1.Time' = None
    message: 'str' = None
    reason: 'str' = None
    signal: 'int' = None
    startedAt: 'meta_v1.Time' = None


@dataclass
class ContainerStateWaiting(DataclassDictMixIn):
    message: 'str' = None
    reason: 'str' = None


@dataclass
class ContainerStatus(DataclassDictMixIn):
    image: 'str'
    imageID: 'str'
    name: 'str'
    ready: 'bool'
    restartCount: 'int'
    containerID: 'str' = None
    lastState: 'ContainerState' = None
    state: 'ContainerState' = None


@dataclass
class DaemonEndpoint(DataclassDictMixIn):
    Port: 'int'


@dataclass
class DownwardAPIProjection(DataclassDictMixIn):
    items: 'List[DownwardAPIVolumeFile]' = None


@dataclass
class DownwardAPIVolumeFile(DataclassDictMixIn):
    path: 'str'
    fieldRef: 'ObjectFieldSelector' = None
    mode: 'int' = None
    resourceFieldRef: 'ResourceFieldSelector' = None


@dataclass
class DownwardAPIVolumeSource(DataclassDictMixIn):
    defaultMode: 'int' = None
    items: 'List[DownwardAPIVolumeFile]' = None


@dataclass
class EmptyDirVolumeSource(DataclassDictMixIn):
    medium: 'str' = None
    sizeLimit: 'resource.Quantity' = None


@dataclass
class EndpointAddress(DataclassDictMixIn):
    ip: 'str'
    hostname: 'str' = None
    nodeName: 'str' = None
    targetRef: 'ObjectReference' = None


@dataclass
class EndpointPort(DataclassDictMixIn):
    port: 'int'
    name: 'str' = None
    protocol: 'str' = None


@dataclass
class EndpointSubset(DataclassDictMixIn):
    addresses: 'List[EndpointAddress]' = None
    notReadyAddresses: 'List[EndpointAddress]' = None
    ports: 'List[EndpointPort]' = None


@dataclass
class Endpoints(DataclassDictMixIn):
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    subsets: 'List[EndpointSubset]' = None


@dataclass
class EndpointsList(DataclassDictMixIn):
    items: 'List[Endpoints]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class EnvFromSource(DataclassDictMixIn):
    configMapRef: 'ConfigMapEnvSource' = None
    prefix: 'str' = None
    secretRef: 'SecretEnvSource' = None


@dataclass
class EnvVar(DataclassDictMixIn):
    name: 'str'
    value: 'str' = None
    valueFrom: 'EnvVarSource' = None


@dataclass
class EnvVarSource(DataclassDictMixIn):
    configMapKeyRef: 'ConfigMapKeySelector' = None
    fieldRef: 'ObjectFieldSelector' = None
    resourceFieldRef: 'ResourceFieldSelector' = None
    secretKeyRef: 'SecretKeySelector' = None


@dataclass
class Event(DataclassDictMixIn):
    involvedObject: 'ObjectReference'
    metadata: 'meta_v1.ObjectMeta'
    action: 'str' = None
    apiVersion: 'str' = None
    count: 'int' = None
    eventTime: 'meta_v1.MicroTime' = None
    firstTimestamp: 'meta_v1.Time' = None
    kind: 'str' = None
    lastTimestamp: 'meta_v1.Time' = None
    message: 'str' = None
    reason: 'str' = None
    related: 'ObjectReference' = None
    reportingComponent: 'str' = None
    reportingInstance: 'str' = None
    series: 'EventSeries' = None
    source: 'EventSource' = None
    type: 'str' = None


@dataclass
class EventList(DataclassDictMixIn):
    items: 'List[Event]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class EventSeries(DataclassDictMixIn):
    count: 'int' = None
    lastObservedTime: 'meta_v1.MicroTime' = None
    state: 'str' = None


@dataclass
class EventSource(DataclassDictMixIn):
    component: 'str' = None
    host: 'str' = None


@dataclass
class ExecAction(DataclassDictMixIn):
    command: 'List[str]' = None


@dataclass
class FCVolumeSource(DataclassDictMixIn):
    fsType: 'str' = None
    lun: 'int' = None
    readOnly: 'bool' = None
    targetWWNs: 'List[str]' = None
    wwids: 'List[str]' = None


@dataclass
class FlexPersistentVolumeSource(DataclassDictMixIn):
    driver: 'str'
    fsType: 'str' = None
    options: 'dict' = None
    readOnly: 'bool' = None
    secretRef: 'SecretReference' = None


@dataclass
class FlexVolumeSource(DataclassDictMixIn):
    driver: 'str'
    fsType: 'str' = None
    options: 'dict' = None
    readOnly: 'bool' = None
    secretRef: 'LocalObjectReference' = None


@dataclass
class FlockerVolumeSource(DataclassDictMixIn):
    datasetName: 'str' = None
    datasetUUID: 'str' = None


@dataclass
class GCEPersistentDiskVolumeSource(DataclassDictMixIn):
    pdName: 'str'
    fsType: 'str' = None
    partition: 'int' = None
    readOnly: 'bool' = None


@dataclass
class GitRepoVolumeSource(DataclassDictMixIn):
    repository: 'str'
    directory: 'str' = None
    revision: 'str' = None


@dataclass
class GlusterfsPersistentVolumeSource(DataclassDictMixIn):
    endpoints: 'str'
    path: 'str'
    endpointsNamespace: 'str' = None
    readOnly: 'bool' = None


@dataclass
class GlusterfsVolumeSource(DataclassDictMixIn):
    endpoints: 'str'
    path: 'str'
    readOnly: 'bool' = None


@dataclass
class HTTPGetAction(DataclassDictMixIn):
    port: 'util_intstr.IntOrString'
    host: 'str' = None
    httpHeaders: 'List[HTTPHeader]' = None
    path: 'str' = None
    scheme: 'str' = None


@dataclass
class HTTPHeader(DataclassDictMixIn):
    name: 'str'
    value: 'str'


@dataclass
class Handler(DataclassDictMixIn):
    exec: 'ExecAction' = None
    httpGet: 'HTTPGetAction' = None
    tcpSocket: 'TCPSocketAction' = None


@dataclass
class HostAlias(DataclassDictMixIn):
    hostnames: 'List[str]' = None
    ip: 'str' = None


@dataclass
class HostPathVolumeSource(DataclassDictMixIn):
    path: 'str'
    type: 'str' = None


@dataclass
class ISCSIPersistentVolumeSource(DataclassDictMixIn):
    iqn: 'str'
    lun: 'int'
    targetPortal: 'str'
    chapAuthDiscovery: 'bool' = None
    chapAuthSession: 'bool' = None
    fsType: 'str' = None
    initiatorName: 'str' = None
    iscsiInterface: 'str' = None
    portals: 'List[str]' = None
    readOnly: 'bool' = None
    secretRef: 'SecretReference' = None


@dataclass
class ISCSIVolumeSource(DataclassDictMixIn):
    iqn: 'str'
    lun: 'int'
    targetPortal: 'str'
    chapAuthDiscovery: 'bool' = None
    chapAuthSession: 'bool' = None
    fsType: 'str' = None
    initiatorName: 'str' = None
    iscsiInterface: 'str' = None
    portals: 'List[str]' = None
    readOnly: 'bool' = None
    secretRef: 'LocalObjectReference' = None


@dataclass
class KeyToPath(DataclassDictMixIn):
    key: 'str'
    path: 'str'
    mode: 'int' = None


@dataclass
class Lifecycle(DataclassDictMixIn):
    postStart: 'Handler' = None
    preStop: 'Handler' = None


@dataclass
class LimitRange(DataclassDictMixIn):
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'LimitRangeSpec' = None


@dataclass
class LimitRangeItem(DataclassDictMixIn):
    default: 'dict' = None
    defaultRequest: 'dict' = None
    max: 'dict' = None
    maxLimitRequestRatio: 'dict' = None
    min: 'dict' = None
    type: 'str' = None


@dataclass
class LimitRangeList(DataclassDictMixIn):
    items: 'List[LimitRange]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class LimitRangeSpec(DataclassDictMixIn):
    limits: 'List[LimitRangeItem]'


@dataclass
class LoadBalancerIngress(DataclassDictMixIn):
    hostname: 'str' = None
    ip: 'str' = None


@dataclass
class LoadBalancerStatus(DataclassDictMixIn):
    ingress: 'List[LoadBalancerIngress]' = None


@dataclass
class LocalObjectReference(DataclassDictMixIn):
    name: 'str' = None


@dataclass
class LocalVolumeSource(DataclassDictMixIn):
    path: 'str'
    fsType: 'str' = None


@dataclass
class NFSVolumeSource(DataclassDictMixIn):
    path: 'str'
    server: 'str'
    readOnly: 'bool' = None


@dataclass
class Namespace(DataclassDictMixIn):
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'NamespaceSpec' = None
    status: 'NamespaceStatus' = None


@dataclass
class NamespaceList(DataclassDictMixIn):
    items: 'List[Namespace]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class NamespaceSpec(DataclassDictMixIn):
    finalizers: 'List[str]' = None


@dataclass
class NamespaceStatus(DataclassDictMixIn):
    phase: 'str' = None


@dataclass
class Node(DataclassDictMixIn):
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'NodeSpec' = None
    status: 'NodeStatus' = None


@dataclass
class NodeAddress(DataclassDictMixIn):
    address: 'str'
    type: 'str'


@dataclass
class NodeAffinity(DataclassDictMixIn):
    preferredDuringSchedulingIgnoredDuringExecution: 'List[PreferredSchedulingTerm]' = None
    requiredDuringSchedulingIgnoredDuringExecution: 'NodeSelector' = None


@dataclass
class NodeCondition(DataclassDictMixIn):
    status: 'str'
    type: 'str'
    lastHeartbeatTime: 'meta_v1.Time' = None
    lastTransitionTime: 'meta_v1.Time' = None
    message: 'str' = None
    reason: 'str' = None


@dataclass
class NodeConfigSource(DataclassDictMixIn):
    configMap: 'ConfigMapNodeConfigSource' = None


@dataclass
class NodeConfigStatus(DataclassDictMixIn):
    active: 'NodeConfigSource' = None
    assigned: 'NodeConfigSource' = None
    error: 'str' = None
    lastKnownGood: 'NodeConfigSource' = None


@dataclass
class NodeDaemonEndpoints(DataclassDictMixIn):
    kubeletEndpoint: 'DaemonEndpoint' = None


@dataclass
class NodeList(DataclassDictMixIn):
    items: 'List[Node]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class NodeSelector(DataclassDictMixIn):
    nodeSelectorTerms: 'List[NodeSelectorTerm]'


@dataclass
class NodeSelectorRequirement(DataclassDictMixIn):
    key: 'str'
    operator: 'str'
    values: 'List[str]' = None


@dataclass
class NodeSelectorTerm(DataclassDictMixIn):
    matchExpressions: 'List[NodeSelectorRequirement]' = None
    matchFields: 'List[NodeSelectorRequirement]' = None


@dataclass
class NodeSpec(DataclassDictMixIn):
    configSource: 'NodeConfigSource' = None
    externalID: 'str' = None
    podCIDR: 'str' = None
    providerID: 'str' = None
    taints: 'List[Taint]' = None
    unschedulable: 'bool' = None


@dataclass
class NodeStatus(DataclassDictMixIn):
    addresses: 'List[NodeAddress]' = None
    allocatable: 'dict' = None
    capacity: 'dict' = None
    conditions: 'List[NodeCondition]' = None
    config: 'NodeConfigStatus' = None
    daemonEndpoints: 'NodeDaemonEndpoints' = None
    images: 'List[ContainerImage]' = None
    nodeInfo: 'NodeSystemInfo' = None
    phase: 'str' = None
    volumesAttached: 'List[AttachedVolume]' = None
    volumesInUse: 'List[str]' = None


@dataclass
class NodeSystemInfo(DataclassDictMixIn):
    architecture: 'str'
    bootID: 'str'
    containerRuntimeVersion: 'str'
    kernelVersion: 'str'
    kubeProxyVersion: 'str'
    kubeletVersion: 'str'
    machineID: 'str'
    operatingSystem: 'str'
    osImage: 'str'
    systemUUID: 'str'


@dataclass
class ObjectFieldSelector(DataclassDictMixIn):
    fieldPath: 'str'
    apiVersion: 'str' = None


@dataclass
class ObjectReference(DataclassDictMixIn):
    apiVersion: 'str' = None
    fieldPath: 'str' = None
    kind: 'str' = None
    name: 'str' = None
    namespace: 'str' = None
    resourceVersion: 'str' = None
    uid: 'str' = None


@dataclass
class PersistentVolume(DataclassDictMixIn):
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'PersistentVolumeSpec' = None
    status: 'PersistentVolumeStatus' = None


@dataclass
class PersistentVolumeClaim(DataclassDictMixIn):
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'PersistentVolumeClaimSpec' = None
    status: 'PersistentVolumeClaimStatus' = None


@dataclass
class PersistentVolumeClaimCondition(DataclassDictMixIn):
    status: 'str'
    type: 'str'
    lastProbeTime: 'meta_v1.Time' = None
    lastTransitionTime: 'meta_v1.Time' = None
    message: 'str' = None
    reason: 'str' = None


@dataclass
class PersistentVolumeClaimList(DataclassDictMixIn):
    items: 'List[PersistentVolumeClaim]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class PersistentVolumeClaimSpec(DataclassDictMixIn):
    accessModes: 'List[str]' = None
    dataSource: 'TypedLocalObjectReference' = None
    resources: 'ResourceRequirements' = None
    selector: 'meta_v1.LabelSelector' = None
    storageClassName: 'str' = None
    volumeMode: 'str' = None
    volumeName: 'str' = None


@dataclass
class PersistentVolumeClaimStatus(DataclassDictMixIn):
    accessModes: 'List[str]' = None
    capacity: 'dict' = None
    conditions: 'List[PersistentVolumeClaimCondition]' = None
    phase: 'str' = None


@dataclass
class PersistentVolumeClaimVolumeSource(DataclassDictMixIn):
    claimName: 'str'
    readOnly: 'bool' = None


@dataclass
class PersistentVolumeList(DataclassDictMixIn):
    items: 'List[PersistentVolume]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class PersistentVolumeSpec(DataclassDictMixIn):
    accessModes: 'List[str]' = None
    awsElasticBlockStore: 'AWSElasticBlockStoreVolumeSource' = None
    azureDisk: 'AzureDiskVolumeSource' = None
    azureFile: 'AzureFilePersistentVolumeSource' = None
    capacity: 'dict' = None
    cephfs: 'CephFSPersistentVolumeSource' = None
    cinder: 'CinderPersistentVolumeSource' = None
    claimRef: 'ObjectReference' = None
    csi: 'CSIPersistentVolumeSource' = None
    fc: 'FCVolumeSource' = None
    flexVolume: 'FlexPersistentVolumeSource' = None
    flocker: 'FlockerVolumeSource' = None
    gcePersistentDisk: 'GCEPersistentDiskVolumeSource' = None
    glusterfs: 'GlusterfsPersistentVolumeSource' = None
    hostPath: 'HostPathVolumeSource' = None
    iscsi: 'ISCSIPersistentVolumeSource' = None
    local: 'LocalVolumeSource' = None
    mountOptions: 'List[str]' = None
    nfs: 'NFSVolumeSource' = None
    nodeAffinity: 'VolumeNodeAffinity' = None
    persistentVolumeReclaimPolicy: 'str' = None
    photonPersistentDisk: 'PhotonPersistentDiskVolumeSource' = None
    portworxVolume: 'PortworxVolumeSource' = None
    quobyte: 'QuobyteVolumeSource' = None
    rbd: 'RBDPersistentVolumeSource' = None
    scaleIO: 'ScaleIOPersistentVolumeSource' = None
    storageClassName: 'str' = None
    storageos: 'StorageOSPersistentVolumeSource' = None
    volumeMode: 'str' = None
    vsphereVolume: 'VsphereVirtualDiskVolumeSource' = None


@dataclass
class PersistentVolumeStatus(DataclassDictMixIn):
    message: 'str' = None
    phase: 'str' = None
    reason: 'str' = None


@dataclass
class PhotonPersistentDiskVolumeSource(DataclassDictMixIn):
    pdID: 'str'
    fsType: 'str' = None


@dataclass
class Pod(DataclassDictMixIn):
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'PodSpec' = None
    status: 'PodStatus' = None


@dataclass
class PodAffinity(DataclassDictMixIn):
    preferredDuringSchedulingIgnoredDuringExecution: 'List[WeightedPodAffinityTerm]' = None
    requiredDuringSchedulingIgnoredDuringExecution: 'List[PodAffinityTerm]' = None


@dataclass
class PodAffinityTerm(DataclassDictMixIn):
    topologyKey: 'str'
    labelSelector: 'meta_v1.LabelSelector' = None
    namespaces: 'List[str]' = None


@dataclass
class PodAntiAffinity(DataclassDictMixIn):
    preferredDuringSchedulingIgnoredDuringExecution: 'List[WeightedPodAffinityTerm]' = None
    requiredDuringSchedulingIgnoredDuringExecution: 'List[PodAffinityTerm]' = None


@dataclass
class PodCondition(DataclassDictMixIn):
    status: 'str'
    type: 'str'
    lastProbeTime: 'meta_v1.Time' = None
    lastTransitionTime: 'meta_v1.Time' = None
    message: 'str' = None
    reason: 'str' = None


@dataclass
class PodDNSConfig(DataclassDictMixIn):
    nameservers: 'List[str]' = None
    options: 'List[PodDNSConfigOption]' = None
    searches: 'List[str]' = None


@dataclass
class PodDNSConfigOption(DataclassDictMixIn):
    name: 'str' = None
    value: 'str' = None


@dataclass
class PodList(DataclassDictMixIn):
    items: 'List[Pod]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class PodReadinessGate(DataclassDictMixIn):
    conditionType: 'str'


@dataclass
class PodSecurityContext(DataclassDictMixIn):
    fsGroup: 'int' = None
    runAsGroup: 'int' = None
    runAsNonRoot: 'bool' = None
    runAsUser: 'int' = None
    seLinuxOptions: 'SELinuxOptions' = None
    supplementalGroups: 'List[int]' = None
    sysctls: 'List[Sysctl]' = None
    windowsOptions: 'WindowsSecurityContextOptions' = None


@dataclass
class PodSpec(DataclassDictMixIn):
    containers: 'List[Container]'
    activeDeadlineSeconds: 'int' = None
    affinity: 'Affinity' = None
    automountServiceAccountToken: 'bool' = None
    dnsConfig: 'PodDNSConfig' = None
    dnsPolicy: 'str' = None
    enableServiceLinks: 'bool' = None
    hostAliases: 'List[HostAlias]' = None
    hostIPC: 'bool' = None
    hostNetwork: 'bool' = None
    hostPID: 'bool' = None
    hostname: 'str' = None
    imagePullSecrets: 'List[LocalObjectReference]' = None
    initContainers: 'List[Container]' = None
    nodeName: 'str' = None
    nodeSelector: 'dict' = None
    preemptionPolicy: 'str' = None
    priority: 'int' = None
    priorityClassName: 'str' = None
    readinessGates: 'List[PodReadinessGate]' = None
    restartPolicy: 'str' = None
    runtimeClassName: 'str' = None
    schedulerName: 'str' = None
    securityContext: 'PodSecurityContext' = None
    serviceAccount: 'str' = None
    serviceAccountName: 'str' = None
    shareProcessNamespace: 'bool' = None
    subdomain: 'str' = None
    terminationGracePeriodSeconds: 'int' = None
    tolerations: 'List[Toleration]' = None
    volumes: 'List[Volume]' = None


@dataclass
class PodStatus(DataclassDictMixIn):
    conditions: 'List[PodCondition]' = None
    containerStatuses: 'List[ContainerStatus]' = None
    hostIP: 'str' = None
    initContainerStatuses: 'List[ContainerStatus]' = None
    message: 'str' = None
    nominatedNodeName: 'str' = None
    phase: 'str' = None
    podIP: 'str' = None
    qosClass: 'str' = None
    reason: 'str' = None
    startTime: 'meta_v1.Time' = None


@dataclass
class PodTemplate(DataclassDictMixIn):
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    template: 'PodTemplateSpec' = None


@dataclass
class PodTemplateList(DataclassDictMixIn):
    items: 'List[PodTemplate]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class PodTemplateSpec(DataclassDictMixIn):
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'PodSpec' = None


@dataclass
class PortworxVolumeSource(DataclassDictMixIn):
    volumeID: 'str'
    fsType: 'str' = None
    readOnly: 'bool' = None


@dataclass
class PreferredSchedulingTerm(DataclassDictMixIn):
    preference: 'NodeSelectorTerm'
    weight: 'int'


@dataclass
class Probe(DataclassDictMixIn):
    exec: 'ExecAction' = None
    failureThreshold: 'int' = None
    httpGet: 'HTTPGetAction' = None
    initialDelaySeconds: 'int' = None
    periodSeconds: 'int' = None
    successThreshold: 'int' = None
    tcpSocket: 'TCPSocketAction' = None
    timeoutSeconds: 'int' = None


@dataclass
class ProjectedVolumeSource(DataclassDictMixIn):
    sources: 'List[VolumeProjection]'
    defaultMode: 'int' = None


@dataclass
class QuobyteVolumeSource(DataclassDictMixIn):
    registry: 'str'
    volume: 'str'
    group: 'str' = None
    readOnly: 'bool' = None
    tenant: 'str' = None
    user: 'str' = None


@dataclass
class RBDPersistentVolumeSource(DataclassDictMixIn):
    image: 'str'
    monitors: 'List[str]'
    fsType: 'str' = None
    keyring: 'str' = None
    pool: 'str' = None
    readOnly: 'bool' = None
    secretRef: 'SecretReference' = None
    user: 'str' = None


@dataclass
class RBDVolumeSource(DataclassDictMixIn):
    image: 'str'
    monitors: 'List[str]'
    fsType: 'str' = None
    keyring: 'str' = None
    pool: 'str' = None
    readOnly: 'bool' = None
    secretRef: 'LocalObjectReference' = None
    user: 'str' = None


@dataclass
class ReplicationController(DataclassDictMixIn):
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'ReplicationControllerSpec' = None
    status: 'ReplicationControllerStatus' = None


@dataclass
class ReplicationControllerCondition(DataclassDictMixIn):
    status: 'str'
    type: 'str'
    lastTransitionTime: 'meta_v1.Time' = None
    message: 'str' = None
    reason: 'str' = None


@dataclass
class ReplicationControllerList(DataclassDictMixIn):
    items: 'List[ReplicationController]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class ReplicationControllerSpec(DataclassDictMixIn):
    minReadySeconds: 'int' = None
    replicas: 'int' = None
    selector: 'dict' = None
    template: 'PodTemplateSpec' = None


@dataclass
class ReplicationControllerStatus(DataclassDictMixIn):
    replicas: 'int'
    availableReplicas: 'int' = None
    conditions: 'List[ReplicationControllerCondition]' = None
    fullyLabeledReplicas: 'int' = None
    observedGeneration: 'int' = None
    readyReplicas: 'int' = None


@dataclass
class ResourceFieldSelector(DataclassDictMixIn):
    resource: 'str'
    containerName: 'str' = None
    divisor: 'resource.Quantity' = None


@dataclass
class ResourceQuota(DataclassDictMixIn):
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'ResourceQuotaSpec' = None
    status: 'ResourceQuotaStatus' = None


@dataclass
class ResourceQuotaList(DataclassDictMixIn):
    items: 'List[ResourceQuota]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class ResourceQuotaSpec(DataclassDictMixIn):
    hard: 'dict' = None
    scopeSelector: 'ScopeSelector' = None
    scopes: 'List[str]' = None


@dataclass
class ResourceQuotaStatus(DataclassDictMixIn):
    hard: 'dict' = None
    used: 'dict' = None


@dataclass
class ResourceRequirements(DataclassDictMixIn):
    limits: 'dict' = None
    requests: 'dict' = None


@dataclass
class SELinuxOptions(DataclassDictMixIn):
    level: 'str' = None
    role: 'str' = None
    type: 'str' = None
    user: 'str' = None


@dataclass
class ScaleIOPersistentVolumeSource(DataclassDictMixIn):
    gateway: 'str'
    secretRef: 'SecretReference'
    system: 'str'
    fsType: 'str' = None
    protectionDomain: 'str' = None
    readOnly: 'bool' = None
    sslEnabled: 'bool' = None
    storageMode: 'str' = None
    storagePool: 'str' = None
    volumeName: 'str' = None


@dataclass
class ScaleIOVolumeSource(DataclassDictMixIn):
    gateway: 'str'
    secretRef: 'LocalObjectReference'
    system: 'str'
    fsType: 'str' = None
    protectionDomain: 'str' = None
    readOnly: 'bool' = None
    sslEnabled: 'bool' = None
    storageMode: 'str' = None
    storagePool: 'str' = None
    volumeName: 'str' = None


@dataclass
class ScopeSelector(DataclassDictMixIn):
    matchExpressions: 'List[ScopedResourceSelectorRequirement]' = None


@dataclass
class ScopedResourceSelectorRequirement(DataclassDictMixIn):
    operator: 'str'
    scopeName: 'str'
    values: 'List[str]' = None


@dataclass
class Secret(DataclassDictMixIn):
    apiVersion: 'str' = None
    data: 'dict' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    stringData: 'dict' = None
    type: 'str' = None


@dataclass
class SecretEnvSource(DataclassDictMixIn):
    name: 'str' = None
    optional: 'bool' = None


@dataclass
class SecretKeySelector(DataclassDictMixIn):
    key: 'str'
    name: 'str' = None
    optional: 'bool' = None


@dataclass
class SecretList(DataclassDictMixIn):
    items: 'List[Secret]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class SecretProjection(DataclassDictMixIn):
    items: 'List[KeyToPath]' = None
    name: 'str' = None
    optional: 'bool' = None


@dataclass
class SecretReference(DataclassDictMixIn):
    name: 'str' = None
    namespace: 'str' = None


@dataclass
class SecretVolumeSource(DataclassDictMixIn):
    defaultMode: 'int' = None
    items: 'List[KeyToPath]' = None
    optional: 'bool' = None
    secretName: 'str' = None


@dataclass
class SecurityContext(DataclassDictMixIn):
    allowPrivilegeEscalation: 'bool' = None
    capabilities: 'Capabilities' = None
    privileged: 'bool' = None
    procMount: 'str' = None
    readOnlyRootFilesystem: 'bool' = None
    runAsGroup: 'int' = None
    runAsNonRoot: 'bool' = None
    runAsUser: 'int' = None
    seLinuxOptions: 'SELinuxOptions' = None
    windowsOptions: 'WindowsSecurityContextOptions' = None


@dataclass
class Service(DataclassDictMixIn):
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    spec: 'ServiceSpec' = None
    status: 'ServiceStatus' = None


@dataclass
class ServiceAccount(DataclassDictMixIn):
    apiVersion: 'str' = None
    automountServiceAccountToken: 'bool' = None
    imagePullSecrets: 'List[LocalObjectReference]' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    secrets: 'List[ObjectReference]' = None


@dataclass
class ServiceAccountList(DataclassDictMixIn):
    items: 'List[ServiceAccount]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class ServiceAccountTokenProjection(DataclassDictMixIn):
    path: 'str'
    audience: 'str' = None
    expirationSeconds: 'int' = None


@dataclass
class ServiceList(DataclassDictMixIn):
    items: 'List[Service]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class ServicePort(DataclassDictMixIn):
    port: 'int'
    name: 'str' = None
    nodePort: 'int' = None
    protocol: 'str' = None
    targetPort: 'util_intstr.IntOrString' = None


@dataclass
class ServiceSpec(DataclassDictMixIn):
    clusterIP: 'str' = None
    externalIPs: 'List[str]' = None
    externalName: 'str' = None
    externalTrafficPolicy: 'str' = None
    healthCheckNodePort: 'int' = None
    loadBalancerIP: 'str' = None
    loadBalancerSourceRanges: 'List[str]' = None
    ports: 'List[ServicePort]' = None
    publishNotReadyAddresses: 'bool' = None
    selector: 'dict' = None
    sessionAffinity: 'str' = None
    sessionAffinityConfig: 'SessionAffinityConfig' = None
    type: 'str' = None


@dataclass
class ServiceStatus(DataclassDictMixIn):
    loadBalancer: 'LoadBalancerStatus' = None


@dataclass
class SessionAffinityConfig(DataclassDictMixIn):
    clientIP: 'ClientIPConfig' = None


@dataclass
class StorageOSPersistentVolumeSource(DataclassDictMixIn):
    fsType: 'str' = None
    readOnly: 'bool' = None
    secretRef: 'ObjectReference' = None
    volumeName: 'str' = None
    volumeNamespace: 'str' = None


@dataclass
class StorageOSVolumeSource(DataclassDictMixIn):
    fsType: 'str' = None
    readOnly: 'bool' = None
    secretRef: 'LocalObjectReference' = None
    volumeName: 'str' = None
    volumeNamespace: 'str' = None


@dataclass
class Sysctl(DataclassDictMixIn):
    name: 'str'
    value: 'str'


@dataclass
class TCPSocketAction(DataclassDictMixIn):
    port: 'util_intstr.IntOrString'
    host: 'str' = None


@dataclass
class Taint(DataclassDictMixIn):
    effect: 'str'
    key: 'str'
    timeAdded: 'meta_v1.Time' = None
    value: 'str' = None


@dataclass
class Toleration(DataclassDictMixIn):
    effect: 'str' = None
    key: 'str' = None
    operator: 'str' = None
    tolerationSeconds: 'int' = None
    value: 'str' = None


@dataclass
class TopologySelectorLabelRequirement(DataclassDictMixIn):
    key: 'str'
    values: 'List[str]'


@dataclass
class TopologySelectorTerm(DataclassDictMixIn):
    matchLabelExpressions: 'List[TopologySelectorLabelRequirement]' = None


@dataclass
class TypedLocalObjectReference(DataclassDictMixIn):
    kind: 'str'
    name: 'str'
    apiGroup: 'str' = None


@dataclass
class Volume(DataclassDictMixIn):
    name: 'str'
    awsElasticBlockStore: 'AWSElasticBlockStoreVolumeSource' = None
    azureDisk: 'AzureDiskVolumeSource' = None
    azureFile: 'AzureFileVolumeSource' = None
    cephfs: 'CephFSVolumeSource' = None
    cinder: 'CinderVolumeSource' = None
    configMap: 'ConfigMapVolumeSource' = None
    csi: 'CSIVolumeSource' = None
    downwardAPI: 'DownwardAPIVolumeSource' = None
    emptyDir: 'EmptyDirVolumeSource' = None
    fc: 'FCVolumeSource' = None
    flexVolume: 'FlexVolumeSource' = None
    flocker: 'FlockerVolumeSource' = None
    gcePersistentDisk: 'GCEPersistentDiskVolumeSource' = None
    gitRepo: 'GitRepoVolumeSource' = None
    glusterfs: 'GlusterfsVolumeSource' = None
    hostPath: 'HostPathVolumeSource' = None
    iscsi: 'ISCSIVolumeSource' = None
    nfs: 'NFSVolumeSource' = None
    persistentVolumeClaim: 'PersistentVolumeClaimVolumeSource' = None
    photonPersistentDisk: 'PhotonPersistentDiskVolumeSource' = None
    portworxVolume: 'PortworxVolumeSource' = None
    projected: 'ProjectedVolumeSource' = None
    quobyte: 'QuobyteVolumeSource' = None
    rbd: 'RBDVolumeSource' = None
    scaleIO: 'ScaleIOVolumeSource' = None
    secret: 'SecretVolumeSource' = None
    storageos: 'StorageOSVolumeSource' = None
    vsphereVolume: 'VsphereVirtualDiskVolumeSource' = None


@dataclass
class VolumeDevice(DataclassDictMixIn):
    devicePath: 'str'
    name: 'str'


@dataclass
class VolumeMount(DataclassDictMixIn):
    mountPath: 'str'
    name: 'str'
    mountPropagation: 'str' = None
    readOnly: 'bool' = None
    subPath: 'str' = None
    subPathExpr: 'str' = None


@dataclass
class VolumeNodeAffinity(DataclassDictMixIn):
    required: 'NodeSelector' = None


@dataclass
class VolumeProjection(DataclassDictMixIn):
    configMap: 'ConfigMapProjection' = None
    downwardAPI: 'DownwardAPIProjection' = None
    secret: 'SecretProjection' = None
    serviceAccountToken: 'ServiceAccountTokenProjection' = None


@dataclass
class VsphereVirtualDiskVolumeSource(DataclassDictMixIn):
    volumePath: 'str'
    fsType: 'str' = None
    storagePolicyID: 'str' = None
    storagePolicyName: 'str' = None


@dataclass
class WeightedPodAffinityTerm(DataclassDictMixIn):
    podAffinityTerm: 'PodAffinityTerm'
    weight: 'int'


@dataclass
class WindowsSecurityContextOptions(DataclassDictMixIn):
    gmsaCredentialSpec: 'str' = None
    gmsaCredentialSpecName: 'str' = None


