# autogenerated module
from dataclasses import dataclass, field
from typing import List

from ..core.dataclasses_dict import DataclassDictMixIn

from . import meta_v1


@dataclass
class AggregationRule(DataclassDictMixIn):
    clusterRoleSelectors: 'List[meta_v1.LabelSelector]' = None


@dataclass
class ClusterRole(DataclassDictMixIn):
    aggregationRule: 'AggregationRule' = None
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    rules: 'List[PolicyRule]' = None


@dataclass
class ClusterRoleBinding(DataclassDictMixIn):
    roleRef: 'RoleRef'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    subjects: 'List[Subject]' = None


@dataclass
class ClusterRoleBindingList(DataclassDictMixIn):
    items: 'List[ClusterRoleBinding]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class ClusterRoleList(DataclassDictMixIn):
    items: 'List[ClusterRole]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class PolicyRule(DataclassDictMixIn):
    verbs: 'List[str]'
    apiGroups: 'List[str]' = None
    nonResourceURLs: 'List[str]' = None
    resourceNames: 'List[str]' = None
    resources: 'List[str]' = None


@dataclass
class Role(DataclassDictMixIn):
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    rules: 'List[PolicyRule]' = None


@dataclass
class RoleBinding(DataclassDictMixIn):
    roleRef: 'RoleRef'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ObjectMeta' = None
    subjects: 'List[Subject]' = None


@dataclass
class RoleBindingList(DataclassDictMixIn):
    items: 'List[RoleBinding]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class RoleList(DataclassDictMixIn):
    items: 'List[Role]'
    apiVersion: 'str' = None
    kind: 'str' = None
    metadata: 'meta_v1.ListMeta' = None


@dataclass
class RoleRef(DataclassDictMixIn):
    apiGroup: 'str'
    kind: 'str'
    name: 'str'


@dataclass
class Subject(DataclassDictMixIn):
    kind: 'str'
    name: 'str'
    apiGroup: 'str' = None
    namespace: 'str' = None


